/**/

///<reference path=".config/sa.d.ts" />
const VK_RMB = 2;//鼠标右键
const VK_LMB = 1;//鼠标左键
const WP_KNIFE = 4;//小刀
const VEC_COEF = 100;
var player = new Player(0);
var player_char = player.getChar();
var target_marker = 0;
var target_char = new Char(0);
var last_target_handle = 0;
var target_handle = 0;
while (true) {
    wait(50);
    if (player.isPlaying() && player.isControlOn() && player_char.isCurrentWeapon(WP_KNIFE)) {
        if (Pad.IsKeyPressed(VK_RMB)) {
            //搜索行人 离玩家最近的
            /*在0-127 256-256+127.... tmp_handle在35584-256~35584-128中遍历 mod 256 < 127

            */
            var player_pos = player_char.getCoordinates();    
            for (var tmp_handle = 0; tmp_handle < 35584; tmp_handle++) {
                if (isCharOk(tmp_handle)) {
                    if (!Char.DoesExist(target_handle) || Char.IsDead(target_handle)) {
                        target_handle = tmp_handle;
                    }
                    target_handle = closer(target_handle,tmp_handle);
                }
                //tmp_handle update
                if (tmp_handle % 256 >= 128) {
                    tmp_handle += 127;
                }
                if (tmp_handle % 10000 == 1) {
                    wait(1);
                }
            }
            //end for
            if (last_target_handle != target_handle) {//更换目标
                if (Blip.DoesExist(target_marker)) {
                    //log("Removed", Number(target_marker), "on",last_target_handle,"because target is changed to",target_handle);
                    target_marker.remove();//上一次的清理
                }
            }
            last_target_handle = target_handle;          
            if (!Char.DoesExist(target_handle)) {
                log("CLOSEST_CHAR is not found");
                continue;
            }
            target_char = new Char(target_handle);
            //设置标记->等待左键->传送->播放动画->击杀
            //标记
            if (!Blip.DoesExist(target_marker)) {
                target_marker = Blip.AddForChar(target_char).changeDisplay(1);//Blip only 2 Marker only 1 Both 3 neither 0
                //log("Blip", Number(target_marker), "created on",target_handle);
            }
            //左键
            target_char.setIsTargetPriority(true);
            if (Pad.IsKeyPressed(VK_LMB) && Char.DoesExist(target_char)) {
                //log("Removed", Number(target_marker), "on",target_handle,"because of kill")
                //设置相机->玩家无敌->锁定移动->传送->动画->击杀
                if (Blip.DoesExist(target_marker)) {
                    target_marker.remove();
                }
                var camera_pos = Camera.GetActiveCoordinates();
                var camera_pointat = Camera.GetActivePointAt();
                Streaming.RequestAnimation("KNIFE");
                while (!Streaming.HasAnimationLoaded("KNIFE")) {
                    wait(1);
                }
                //log("KILLING",Number(target_char),"whose health is",target_char.getHealth(),"and who is",Char.IsDead(target_char),"of dead");
                //log("KNIFE LOADED!!!");
                //设置相机
                Camera.SetFixedPosition(camera_pos.x,camera_pos.y,camera_pos.z,0,0,0);
                Camera.PointAtPoint(camera_pointat.x,camera_pointat.y,camera_pointat.z,2);
                if (!Char.DoesExist(target_char)) {
                    continue;
                }
                //目标锁定移动
                target_char.freezePosition(true);
                var tgp = target_char.getCoordinates();
                var tg_front = target_char.getOffsetInWorldCoords(0, 1, 0);
                var tg_back = target_char.getOffsetInWorldCoords(0, -1, 0);
                //玩家无敌 传送
                player_char.setProofs(true,true,true,true,true).setCoordinatesNoOffset(tg_back.x,tg_back.y,tg_back.z).setHeading(target_char.getHeading());
                wait(1);
                if (!Char.DoesExist(target_char)) {
                    continue;
                }                
                target_char.setHeading(player_char.getHeading());
                wait(1);
                Task.ShootAtCoord(target_char,tg_front.x,tg_front.y,tg_front.z,5000);
                wait(1);
                //log(Number(target_char),tg_front.x)
                Task.PlayAnimNonInterruptable(player_char,"KILL_PARTIAL","KNIFE",4.0,1,0,0,0,500);
                wait(1);
                Camera.RestoreJumpcut();
                Task.PlayAnimNonInterruptable(player_char,"KILL_KNIFE_PLAYER","KNIFE",1.0,1,0,0,0,2300);
                wait(1);
                if (target_char.isDucking()) {
                    //log("target is ducking");
                    Task.ToggleDuck(target_char,false);
                    Task.StandStill(target_char,1000);
                    target_char.clearTasksImmediately().setAllowedToDuck(false);
                }
                Task.PlayAnimNonInterruptable(target_char,"KILL_KNIFE_PED_DAMAGE","KNIFE",1.0,1,0,0,0,2000);
                wait(1000);
                if (!Char.DoesExist(target_char)) {
                    continue;
                }
                Fx.AddBlood(tgp.x,tgp.y,tgp.z,0,0,3,200,target_char);
                wait(500);
                if (!Char.DoesExist(target_char)) {
                    continue;
                }
                Task.DieNamedAnim(target_char,"KILL_KNIFE_PED_DIE","KNIFE",4.0,0);
                target_char.setIsTargetPriority(false).freezePosition(false);
                player_char.freezePosition(false).setProofs(false,false,false,false,false);
                //player_char.setProofs(true,true,true,true,true)
                //wait(500);
                //log(wait_time/1000,"seconds costed (at least)");
            }
        }
        else {
            if (Blip.DoesExist(target_marker)) {
                //log("Removed", Number(target_marker), "on",last_target_handle,"because of RMB not pressed")
                target_marker.remove();     
            }
        }
    }
}

function isCharOk(char_handle) {
    var tmpchar = new Char(char_handle);
    if (Number(player_char) == char_handle || 
    !Char.DoesExist(char_handle) || 
    Char.IsDead(char_handle) ||
    tmpchar.isInAnyCar() ||
    tmpchar.isInAnyHeli() ||
    tmpchar.isInAnyPlane() ||
    tmpchar.isInAnyTrain()
    ) {
        //log(char_handle,"is player or not exist or is dead ")
        return false;
    }
    //log(char_handle,"is ok")
    return true;
}
function closer(char_handle_a,char_handle_b) {
    if (!Char.DoesExist(char_handle_a) || !Char.DoesExist(char_handle_b)) {
        return undefined;
    }
    var char_a = new Char(char_handle_a);
    var char_b = new Char(char_handle_b);
    var ap = char_a.getCoordinates();
    var bp = char_b.getCoordinates();
    var cp = Camera.GetActiveCoordinates();
    var cpat = Camera.GetActivePointAt();
    //var looking_vec = {x:VEC_COEF*(cpat.x-cp.x), y:VEC_COEF*(cpat.y-cp.y), z:VEC_COEF*(cpat.z-cp.z)};
    var player_p = player_char.getCoordinates();
    var far = {
        x:player_p.x + VEC_COEF*(cpat.x - cp.x), 
        y:player_p.y + VEC_COEF*(cpat.y - cp.y), 
        z:player_p.z + VEC_COEF*(cpat.z - cp.z)
    };
    var dist_a = Math.GetDistanceBetweenCoords3D(ap.x,ap.y,ap.z,far.x,far.y,far.z) + Math.GetDistanceBetweenCoords3D(ap.x,ap.y,ap.z,player_p.x,player_p.y,player_p.z);
    var dist_b = Math.GetDistanceBetweenCoords3D(bp.x,bp.y,bp.z,far.x,far.y,far.z) + Math.GetDistanceBetweenCoords3D(bp.x,bp.y,bp.z,player_p.x,player_p.y,player_p.z);
    
    return (dist_a < dist_b) ? char_handle_a : char_handle_b;
}